(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('factor-utils'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('factor-common', ['exports', '@angular/core', 'factor-utils', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['factor-common'] = {}, global.ng.core, global['factor-utils'], global.ng.common));
}(this, (function (exports, i0, factorUtils, common) { 'use strict';

    var AvatarComponent = /** @class */ (function () {
        function AvatarComponent(colorService) {
            this.colorService = colorService;
            this.class = '';
        }
        Object.defineProperty(AvatarComponent.prototype, "src", {
            set: function (value) {
                var _this = this;
                if (value && value.trim() != '') {
                    this._src = value;
                    var image_1 = new Image();
                    image_1.src = value;
                    image_1.onload = function () {
                        if ("decode" in image_1) {
                            image_1.decode().then(function () {
                                _this.loaded = true;
                            });
                        }
                        else {
                            console.error('Image.decode not available.');
                        }
                    };
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AvatarComponent.prototype, "label", {
            set: function (value) {
                this._label = value;
                this.initials = this.getInitials(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AvatarComponent.prototype, "backgroundColor", {
            get: function () {
                return this.color || this.colorService.hex(this._label);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AvatarComponent.prototype, "backgroundImage", {
            get: function () {
                return this._src ? "url(" + this._src + ")" : '';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AvatarComponent.prototype, "hostClasses", {
            get: function () {
                return [
                    'ft-avatar',
                    this.class
                ].join(' ');
            },
            enumerable: false,
            configurable: true
        });
        AvatarComponent.prototype.ngOnInit = function () {
        };
        AvatarComponent.prototype.getInitials = function (value) {
            var allInitials = value.match(/\b\w/g) || [];
            var initials = ((allInitials.shift() || '') + (allInitials.pop() || '')).toUpperCase();
            return initials;
        };
        return AvatarComponent;
    }());
    AvatarComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ft-avatar',
                    template: "<div *ngIf=\"!loaded\">{{ initials }}</div>\n",
                    styles: [":host{--default-size:var(--size,3rem);display:inline-flex;align-items:center;justify-content:center;color:#fff;background-size:cover;background-repeat:no-repeat;border-radius:calc(var(--default-size) / 2);font-size:calc(var(--default-size) - (var(--default-size) * .6));min-width:var(--default-size);min-height:var(--default-size);cursor:default;-webkit-user-select:none;user-select:none}div{font-size:1em;line-height:1em}"]
                },] }
    ];
    AvatarComponent.ctorParameters = function () { return [
        { type: factorUtils.ColorService }
    ]; };
    AvatarComponent.propDecorators = {
        color: [{ type: i0.Input }],
        class: [{ type: i0.Input }],
        src: [{ type: i0.Input }],
        label: [{ type: i0.Input }],
        backgroundColor: [{ type: i0.HostBinding, args: ['style.background-color',] }],
        backgroundImage: [{ type: i0.HostBinding, args: ['style.background-image',] }],
        hostClasses: [{ type: i0.HostBinding, args: ['class',] }]
    };

    var IconComponent = /** @class */ (function () {
        function IconComponent(configuration) {
            this.configuration = configuration;
            this.class = '';
        }
        Object.defineProperty(IconComponent.prototype, "collection", {
            set: function (collection) {
                this._collection = collection;
                this.update();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IconComponent.prototype, "mode", {
            set: function (mode) {
                this._mode = mode;
                this.update();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IconComponent.prototype, "name", {
            set: function (name) {
                this._name = name;
                this.update();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IconComponent.prototype, "path", {
            set: function (path) {
                this._path = path;
                this.update();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IconComponent.prototype, "hostClasses", {
            get: function () {
                return [
                    'ft-icon',
                    this.class
                ].join(' ');
            },
            enumerable: false,
            configurable: true
        });
        IconComponent.prototype.ngOnInit = function () {
            this.update();
        };
        IconComponent.prototype.update = function () {
            // Set the default collection if the mode is external
            if (!this._collection) {
                if (this.configuration.icon && this.configuration.icon.collection) {
                    this._collection = this.configuration.icon.collection;
                }
                else if (this.mode === 'external') {
                    this._collection = 'icons';
                }
            }
            if (!this._mode) {
                if (this.configuration.icon && this.configuration.icon.mode) {
                    this._mode = this.configuration.icon.mode;
                }
                else {
                    this._mode = 'external';
                }
            }
            if (this._mode === 'external') {
                // If the icon mode is external
                if (!this._path) {
                    if (this.configuration.icon && this.configuration.icon.path) {
                        this._path = this.configuration.icon.path;
                    }
                    else {
                        this._path = 'assets';
                    }
                }
                this.url = this._path + "/" + this._collection + ".svg#" + this._name;
            }
            else {
                // If the icon mode is inline
                var name = this._collection && this._collection !== 'unset' ? this._collection + "--" + this._name : this._name;
                this.url = "#" + name;
            }
        };
        return IconComponent;
    }());
    IconComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ft-icon',
                    template: "<svg *ngIf=\"!src; else imageTemplate\"><use attr.xlink:href=\"{{ url }}\" attr.href=\"{{ url }}\" /></svg>\n<ng-template #imageTemplate>\n  <img [src]=\"src\" />\n</ng-template>\n",
                    styles: [":host{line-height:0;display:inline-block}:host.ft-icon--1,:host[size=\"1\"]{font-size:1rem}:host.ft-icon--2,:host[size=\"2\"]{font-size:1.5rem}:host.ft-icon--3,:host[size=\"3\"]{font-size:2rem}:host.ft-icon--4,:host[size=\"4\"]{font-size:3rem}:host.ft-icon--5,:host[size=\"5\"]{font-size:4.5rem}:host.ft-icon--6,:host[size=\"6\"]{font-size:8rem}:host.ft-icon--7,:host[size=\"7\"]{font-size:16rem}:host.ft-icon--8,:host[size=\"8\"]{font-size:32rem}svg{width:1em;fill:currentColor}img,svg{height:1em;vertical-align:middle}"]
                },] }
    ];
    IconComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: ['FactorCommonConfiguration',] }] }
    ]; };
    IconComponent.propDecorators = {
        class: [{ type: i0.Input }],
        collection: [{ type: i0.Input }],
        mode: [{ type: i0.Input }],
        name: [{ type: i0.Input }],
        path: [{ type: i0.Input }],
        size: [{ type: i0.Input }],
        src: [{ type: i0.Input }],
        hostClasses: [{ type: i0.HostBinding, args: ['class',] }]
    };

    var ImageComponent = /** @class */ (function () {
        function ImageComponent(element) {
            this.element = element;
            this.class = '';
        }
        ImageComponent.prototype.ngOnInit = function () {
            var _this = this;
            if ("IntersectionObserver" in window) {
                var elementObserver_1 = new IntersectionObserver(function (entries, observer) {
                    entries.forEach(function (entry) {
                        if (entry.isIntersecting) {
                            var image_1 = new Image();
                            image_1.src = _this.src;
                            setTimeout(function () {
                                if (!_this.shown && !_this.error) {
                                    _this.loading = true;
                                }
                            }, 100);
                            image_1.onerror = function () {
                                _this.error = true;
                                _this.loading = false;
                            };
                            image_1.onload = function () {
                                if ("decode" in image_1) {
                                    image_1.decode().then(function () {
                                        _this.loading = false;
                                        _this.shown = true;
                                    });
                                }
                                else {
                                    _this.loading = false;
                                    _this.shown = true;
                                }
                            };
                            elementObserver_1.unobserve(_this.element.nativeElement);
                        }
                    });
                }, {
                    rootMargin: "0px 0px 200px 0px"
                });
                elementObserver_1.observe(this.element.nativeElement);
            }
            else {
                console.error('IntersectionObserver not available.');
                this.loading = false;
                this.shown = true;
            }
        };
        Object.defineProperty(ImageComponent.prototype, "hostClasses", {
            get: function () {
                return [
                    'ft-image',
                    this.class
                ].join(' ');
            },
            enumerable: false,
            configurable: true
        });
        return ImageComponent;
    }());
    ImageComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ft-image',
                    template: "<img *ngIf=\"shown\" [src]=\"src\" />\n<ft-icon name=\"warning\" size=\"2\" *ngIf=\"error\"></ft-icon>\n",
                    styles: [":host{display:inline-block;overflow:hidden;display:flex;align-items:center;justify-content:center}:host.ft-image--loading{background-color:rgba(0,0,0,.03);position:relative;overflow:hidden}:host.ft-image--loading:after{content:\"\";display:block;background-color:rgba(0,0,0,.02);position:absolute;top:0;bottom:0;width:100%;height:100%;transform:translateX(0);animation:placeholder-loading 1.5s ease-in-out infinite}:host.ft-image--error{background-color:rgba(255,0,0,.03)}:host.ft-image--error ft-icon{color:var(--danger)}img{position:relative;z-index:1;max-width:100%;max-height:100%;animation:fade-in .3s}@keyframes fade-in{0%{opacity:0}to{opacity:1}}@keyframes placeholder-loading{0%{transform:translateX(-100%)}to{transform:translateX(100%)}}"]
                },] }
    ];
    ImageComponent.ctorParameters = function () { return [
        { type: i0.ElementRef }
    ]; };
    ImageComponent.propDecorators = {
        class: [{ type: i0.Input }],
        error: [{ type: i0.HostBinding, args: ['class.ft-image--error',] }],
        loading: [{ type: i0.HostBinding, args: ['class.ft-image--loading',] }],
        src: [{ type: i0.Input }],
        hostClasses: [{ type: i0.HostBinding, args: ['class',] }]
    };

    var ProgressComponent = /** @class */ (function () {
        function ProgressComponent() {
            this.class = '';
            this.mode = 'indeterminate';
        }
        ProgressComponent.prototype.ngOnInit = function () {
            this.value = 0;
        };
        Object.defineProperty(ProgressComponent.prototype, "hostClasses", {
            get: function () {
                return [
                    'ft-progress',
                    this.overlay ? 'ft-progress--overlay' : '',
                    this.class
                ].join(' ');
            },
            enumerable: false,
            configurable: true
        });
        return ProgressComponent;
    }());
    ProgressComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ft-progress',
                    template: "<svg [ngStyle]=\"{'--bar-color': color}\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 100 100\" preserveAspectRatio=\"xMidYMid\">\n    <circle class=\"track\" cx=\"50\" cy=\"50\" r=\"40\" />\n    <circle class=\"bar\" [ngClass]=\"mode\" cx=\"50\" cy=\"50\" r=\"40\"\n        [ngStyle]=\"{'stroke-dashoffset': mode == 'determinate' ? 'calc((3.14159265 * 40 * 2 * (100 - '+value+')) / 100)' : null}\">\n    </circle>\n</svg>",
                    styles: [":host{--track-color:rgba(0,0,0,0.08);--bar-color:var(--primary);line-height:0;display:inline-block}:host.ft-progress--1,:host[size=\"1\"]{font-size:1rem}:host.ft-progress--2,:host[size=\"2\"]{font-size:1.5rem}:host.ft-progress--3,:host[size=\"3\"]{font-size:2rem}:host.ft-progress--4,:host[size=\"4\"]{font-size:3rem}:host.ft-progress--5,:host[size=\"5\"]{font-size:4.5rem}:host.ft-progress--6,:host[size=\"6\"]{font-size:8rem}:host.ft-progress--7,:host[size=\"7\"]{font-size:16rem}:host.ft-progress--8,:host[size=\"8\"]{font-size:32rem}:host.ft-progress--overlay{position:fixed;display:flex;align-items:center;justify-content:center;pointer-events:none;z-index:1050;top:0;left:0;right:0;bottom:0;font-size:42px}:host.ft-progress--overlay svg{background:hsla(0,0%,100%,.6);-webkit-backdrop-filter:saturate(50%) blur(3px);backdrop-filter:saturate(50%) blur(3px);box-shadow:0 3px 3px -2px rgba(0,0,0,.2),0 3px 4px 0 rgba(0,0,0,.14),0 1px 8px 0 rgba(0,0,0,.12);border-radius:100vh;padding:.3125rem;animation:progress-reveal .2s;animation-fill-mode:forwards}:host.ft-progress--overlay svg .track{display:none}svg{width:1em;height:1em;vertical-align:middle}svg .track{fill:none;stroke-width:10;stroke:var(--track-color)}svg .bar{fill:none;stroke-opacity:.9;stroke-width:6;stroke:var(--bar-color)}svg .bar.indeterminate{animation:progress-rotation 2s linear infinite}svg .bar.determinate{stroke-dasharray:calc(2 * 3.1415926536 * 40)}@keyframes progress-reveal{0%{transform:translateY(-100%);opacity:0}to{transform:translateY(0);opacity:1}}@keyframes progress-rotation{0%{stroke-dashoffset:0;stroke-dasharray:150.6 100.4}50%{stroke-dasharray:1 250}to{stroke-dashoffset:502;stroke-dasharray:150.6 100.4}}"]
                },] }
    ];
    ProgressComponent.ctorParameters = function () { return []; };
    ProgressComponent.propDecorators = {
        class: [{ type: i0.Input }],
        color: [{ type: i0.Input }],
        mode: [{ type: i0.Input }],
        overlay: [{ type: i0.Input }],
        size: [{ type: i0.Input }],
        value: [{ type: i0.Input }],
        hostClasses: [{ type: i0.HostBinding, args: ['class',] }]
    };

    var ProgressService = /** @class */ (function () {
        function ProgressService(componentFactoryResolver, injector) {
            this.componentFactoryResolver = componentFactoryResolver;
            this.injector = injector;
        }
        ProgressService.prototype.show = function () {
            if (!this.componentRef) {
                this.appRef = this.injector.get(i0.ApplicationRef);
                // 1. Create a component reference from the component 
                this.componentRef = this.componentFactoryResolver
                    .resolveComponentFactory(ProgressComponent)
                    .create(this.injector);
                // 2. Attach component to the appRef so that it's inside the ng component tree
                this.appRef.attachView(this.componentRef.hostView);
                this.componentRef.instance.overlay = true;
                // 3. Get DOM element from component
                var domElem = this.componentRef.hostView
                    .rootNodes[0];
                // 4. Append DOM element to the body
                document.body.appendChild(domElem);
                return true;
            }
            else {
                return false;
            }
        };
        ProgressService.prototype.hide = function () {
            if (this.componentRef) {
                this.appRef.detachView(this.componentRef.hostView);
                this.componentRef.destroy();
                this.componentRef = null;
                return true;
            }
            else {
                return false;
            }
        };
        return ProgressService;
    }());
    ProgressService.ɵprov = i0.ɵɵdefineInjectable({ factory: function ProgressService_Factory() { return new ProgressService(i0.ɵɵinject(i0.ComponentFactoryResolver), i0.ɵɵinject(i0.INJECTOR)); }, token: ProgressService, providedIn: "root" });
    ProgressService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    ProgressService.ctorParameters = function () { return [
        { type: i0.ComponentFactoryResolver },
        { type: i0.Injector }
    ]; };

    var ObserveIntersectingDirective = /** @class */ (function () {
        function ObserveIntersectingDirective(element, platformId) {
            this.element = element;
            this.platformId = platformId;
            this.event = new i0.EventEmitter();
        }
        ObserveIntersectingDirective.prototype.ngOnInit = function () {
            var _this = this;
            if (common.isPlatformBrowser(this.platformId)) {
                if ("IntersectionObserver" in window) {
                    var elementObserver = new IntersectionObserver(function (entries, observer) {
                        entries.forEach(function (entry) {
                            _this.event.emit(entry.isIntersecting);
                        });
                    }, this.options);
                    elementObserver.observe(this.element.nativeElement);
                }
                else {
                    console.error('ftObserveIntersecting not available in this browser.');
                }
            }
        };
        return ObserveIntersectingDirective;
    }());
    ObserveIntersectingDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ftObserveIntersecting]'
                },] }
    ];
    ObserveIntersectingDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: Object, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
    ]; };
    ObserveIntersectingDirective.propDecorators = {
        options: [{ type: i0.Input, args: ['ftObserveIntersectingOptions',] }],
        event: [{ type: i0.Output, args: ['ftObserveIntersecting',] }]
    };

    var CommonModule = /** @class */ (function () {
        function CommonModule() {
        }
        CommonModule.forRoot = function (configuration) {
            return {
                ngModule: CommonModule,
                providers: [
                    { provide: 'FactorCommonConfiguration', useValue: configuration }
                ]
            };
        };
        return CommonModule;
    }());
    CommonModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        AvatarComponent,
                        IconComponent,
                        ProgressComponent,
                        ImageComponent,
                        ObserveIntersectingDirective
                    ],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [
                        AvatarComponent,
                        IconComponent,
                        ImageComponent,
                        ObserveIntersectingDirective,
                        ProgressComponent
                    ]
                },] }
    ];

    /*
     * Public API Surface of common
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AvatarComponent = AvatarComponent;
    exports.CommonModule = CommonModule;
    exports.IconComponent = IconComponent;
    exports.ImageComponent = ImageComponent;
    exports.ObserveIntersectingDirective = ObserveIntersectingDirective;
    exports.ProgressComponent = ProgressComponent;
    exports.ProgressService = ProgressService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=factor-common.umd.js.map
